;;; Sierra Script 1.0 - (do not remove this comment)
;
; SCI Template Game
; By Brian Provinciano
; ******************************************************************************
; titlescreen.sc
; Contains the title screen room.
(script# TITLE)
(include game.sh)
(use main)
(use game)
(use system)
(use motion)
(use user)
(use File)
(use menu)
(use intrface)

(public
	TitleScreen 0
)

(instance TitleScreen of Room
	(properties
		picture scriptNumber
	)
	
	(method (init &tmp [tempStr 200] scoreFile num)
		; Set up the title screen
		(StatusLine disable:)
		(TheMenuBar hide:)
		(super init:)
		(ego init: hide:)
;
;         * Set up the room's music to play here *
		;
		; (send gTheMusic:
		; 	prevSignal(0)
		; 	stop()
		; 	number(scriptNumber)
		; 	loop(-1)
		; 	play()
		; )
;
;         * Add the rest of your initialization stuff here *
		(Display {SCI Tetris} p_at 2 42 p_mode teJustCenter p_color vWHITE p_font 100 p_width 320)
		(Display {SCI Tetris} p_at 1 41 p_mode teJustCenter p_color vBLACK p_font 100 p_width 320)
		(Display {SCI Tetris} p_at 0 40 p_mode teJustCenter p_color vRED p_font 100 p_width 320)
		
		(Display {by Rainer De Temple} p_at 0 150 p_mode teJustCenter p_color vGREY p_font 1 p_width 320)
		(Display {by Rainer De Temple} p_at 1 150 p_mode teJustCenter p_color vRED p_font 1 p_width 320)
		(Format @tempStr {Version %s} version)
		(Display @tempStr p_at 0 162 p_mode teJustCenter p_color vGREY p_font 4 p_width 320)
		(Display @tempStr p_at 1 162 p_mode teJustCenter p_color vLGREY p_font 4 p_width 320)
		
		(Display {Press any key to play} p_at 1 99 p_mode teJustCenter p_color vGREY  p_width 320) ; above
		(Display {Press any key to play} p_at 1 101 p_mode teJustCenter p_color vGREY  p_width 320) ; below
		(Display {Press any key to play} p_at 0 100 p_mode teJustCenter p_color vGREY  p_width 320) ; left
		(Display {Press any key to play} p_at 2 100 p_mode teJustCenter p_color vGREY  p_width 320) ; right
		(Display {Press any key to play} p_at 1 100 p_mode teJustCenter p_color vWHITE  p_width 320)
	)

	(method (handleEvent event)
		(super handleEvent: event)
		(if (not (event claimed?))
			(if
				(and
					(== (event type?) keyDown)
					(== (event message?) `#2)
				)
				(ToggleSound)
			else
;
;                 * If the title screen has music, fade it *
				; (send gTheMusic:fade())
				; End the title screen, start the game
				(curRoom newRoom: 1)
			)
		)
	)	
)